package es.uvigo.ei.sing.aibench.pluginmanager.gui;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Desktop;
import java.awt.Font;

import javax.swing.JDialog;
import javax.swing.JEditorPane;
import javax.swing.JOptionPane;
import javax.swing.UIManager;
import javax.swing.event.HyperlinkEvent;
import javax.swing.event.HyperlinkListener;
import javax.swing.plaf.OptionPaneUI;
import javax.swing.text.html.HTMLDocument;

import es.uvigo.ei.aibench.workbench.Workbench;
import es.uvigo.ei.aibench.workbench.utilities.Utilities;


public class MessageGUI extends JDialog{

	
	private String message;
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private JEditorPane jEditorPaneInfo;
	private boolean isWarning;
	
	public MessageGUI(String message)
	{
		new MessageGUI(message, false);
	}

	public MessageGUI(String message, boolean isWarning)
	{
		super(Workbench.getInstance().getMainFrame());
		this.message = message;
		this.isWarning = isWarning;
		initGUI();
		this.setSize(200, 200);
		Utilities.centerOnOwner(this);
		
	}


	private void initGUI() {
		{
			jEditorPaneInfo = new JEditorPane();
			getContentPane().add(jEditorPaneInfo, BorderLayout.CENTER);
			jEditorPaneInfo.setContentType("text/html");
			
			jEditorPaneInfo.setText(message);
			
			jEditorPaneInfo.setEditable(false);
			jEditorPaneInfo.addHyperlinkListener(new HyperlinkListener() {
                @Override
                public void hyperlinkUpdate(HyperlinkEvent hle) {
                    if (HyperlinkEvent.EventType.ACTIVATED.equals(hle.getEventType())) {
						Desktop desktop = Desktop.isDesktopSupported() ? Desktop.getDesktop() : null;
					    if (desktop != null && desktop.isSupported(Desktop.Action.BROWSE)) {
					        try {
					            desktop.browse(hle.getURL().toURI());
					        } catch (Exception e) {
					        	e.printStackTrace();
					        }
					    }
                    }
                }
            });
			jEditorPaneInfo.setBackground(new Color(0f,0f,0f,0f));	
			
			if(isWarning)
				JOptionPane.showMessageDialog(null, jEditorPaneInfo, "Warning", JOptionPane.WARNING_MESSAGE);
			else
				JOptionPane.showMessageDialog(null, jEditorPaneInfo, "Information", JOptionPane.INFORMATION_MESSAGE);
		}
	}
	
	public static void main(String[] args)
	{
		new MessageGUI("<HTML><font face='verdana'>A new version of OptFlux has been released! Version <b>3.1.1</b> is available. <p>You can download this version using the link <a href='http://www.optflux.org/'>http://www.optflux.org/</a></p></font></HTML>");
	}

}
